=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-13 03:02:49 +0000
+++ loggerhead/controllers/annotate_ui.py	2006-12-13 05:43:00 +0000
@@ -61,8 +61,8 @@
             
         buttons = [
             ('top', turbogears.url('/changes')),
-            ('revision', turbogears.url([ '/revision', revid ])),
-            ('history', turbogears.url([ '/changes', revid ])),
+            ('revision', turbogears.url([ '/revision', revid ], path=path)),
+            ('history', turbogears.url([ '/changes', revid ], path=path)),
         ]
         
         # no navbar for revisions

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-13 03:02:49 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-13 05:43:00 +0000
@@ -51,7 +51,7 @@
         buttons = [
             ('top', turbogears.url('/changes')),
             ('files', turbogears.url([ '/files', revid ])),
-            ('history', turbogears.url([ '/changes', revid ])),
+            ('history', turbogears.url([ '/changes', revid ], path=path)),
         ]
         
         navigation = util.Container(buttons=buttons, revlist=revlist, revid=revid, path=path,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-13 03:02:49 +0000
+++ loggerhead/history.py	2006-12-13 05:43:00 +0000
@@ -364,32 +364,16 @@
                     lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
                     old_lineno = lines[0]
                     new_lineno = lines[1]
-                elif line.startswith('  '):
-                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
-                                                     type='context', line=util.html_clean(line[2:])))
-                    old_lineno += 1
-                    new_lineno += 1
-                elif line.startswith('+ '):
-                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
-                                                     type='insert', line=util.html_clean(line[2:])))
-                    new_lineno += 1
-                elif line.startswith('- '):
-                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
-                                                     type='delete', line=util.html_clean(line[2:])))
-                    old_lineno += 1
                 elif line.startswith(' '):
-                    # why does this happen?
                     chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
                                                      type='context', line=util.html_clean(line[1:])))
                     old_lineno += 1
                     new_lineno += 1
                 elif line.startswith('+'):
-                    # why does this happen?
                     chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
                                                      type='insert', line=util.html_clean(line[1:])))
                     new_lineno += 1
                 elif line.startswith('-'):
-                    # why does this happen?
                     chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
                                                      type='delete', line=util.html_clean(line[1:])))
                     old_lineno += 1
@@ -460,23 +444,29 @@
         
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
+        revision_cache = {}
         
         for revno_str, author, date_str, line_rev_id, text in bzrlib.annotate._annotate_file(self._branch, file_revid, file_id):
             # remember which lines have a new revno and which don't
             if revno_str == '':
-                revno, author, line_rev_id = oldvalues
+                revno, author, line_rev_id, change = oldvalues
                 status = 'same'
             else:
                 revno = self.get_revno(line_rev_id)
-                oldvalues = (revno, author, line_rev_id)
+                change = revision_cache.get(line_rev_id, None)
+                if change is None:
+                    change = self.get_change(line_rev_id)
+                    revision_cache[line_rev_id] = change
+                oldvalues = (revno, author, line_rev_id, change)
                 status = 'changed'
                 parity ^= 1
+                
             
             trunc_revno = revno
             if len(revno) > 10:
                 trunc_revno = revno[:9] + '...'
                 
             yield util.Container(parity=parity, lineno=lineno, revno=revno, author=author, status=status,
-                                 trunc_revno=trunc_revno, revid=line_rev_id, text=util.html_clean(text))
+                                 trunc_revno=trunc_revno, change=change, text=util.html_clean(text))
             lineno += 1
 

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-13 03:02:49 +0000
+++ loggerhead/static/css/style.css	2006-12-13 05:43:00 +0000
@@ -425,7 +425,7 @@
 .annotate td.revno {
 	font-family: monospace;
 	text-align: right;
-	width: 5em;
+	width: 8em;
 	padding-right: 5px;
 	border-right: 1px solid #8cacbb;
 }
@@ -448,6 +448,7 @@
 
 .annotate th.revision {
     text-align: right;
+    padding-right: 5px;
 }
 
 .annotate th.text {

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2006-12-13 03:02:49 +0000
+++ loggerhead/templates/annotate.kid	2006-12-13 05:43:00 +0000
@@ -51,10 +51,12 @@
             <th class="revision"> Revision </th>
             <th class="text"> Contents </th>
         </tr>
+
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${tg.url([ '/revision', line.revid ], path=path)}">${line.trunc_revno}</a>
+                <a py:if="line.status=='changed'" href="${tg.url([ '/revision', line.change.revid ], path=path)}"
+                    title="${line.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${line.change.age})">${line.trunc_revno}</a>
             </td>
             <!--td class="author"> ${util.hide_email(line.author)} </td-->
             <td class="text ${line.status}"> ${XML(line.text)} </td>

